SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Test'!

Object subclass: #SVNDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNDummy class methodsFor: 'dummy' stamp: 'rkrk 2/1/2008 22:10'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'convenience' stamp: 'rkrk 2/1/2008 02:40'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/4/2008 14:22'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/4/2008 14:22'!
m2
	^ 2! !

Object subclass: #SVNElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/1/2008 03:07'!
readElementFrom: aPath

	^self subclassResponsibility.! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/1/2008 03:53'!
writeElementTo: aPath

	^self subclassResponsibility.! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/1/2008 02:20'!
for: aCompiledMethod 
	
	^ self methodReference: aCompiledMethod methodReference.! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 21:38'!
methodReference: aMethodReference 
	
	^ self new
		methodReference: aMethodReference;
		yourself! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/1/2008 03:27'!
readElementFrom: aPath

	^SVNMethod new
		readElementFrom: aPath;
		yourself.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 1/6/2008 22:07'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodClass = otherMethod methodClass &
			(self methodReference = otherMethod methodReference).! !

!SVNMethod methodsFor: 'modifying system' stamp: 'rkrk 2/1/2008 03:22'!
compileMethodFrom: contents

	| sourceCode class selector |
	class := self extractClassFrom: contents.
	sourceCode := self extractSourceCodeFrom: contents.
	selector := class compile: sourceCode.
	^ class >> selector! !

!SVNMethod methodsFor: 'serializing' stamp: 'cop 2/1/2008 18:43'!
contentsForFile
	
	"Mapping method to contents of a file"
	self flag: #TODO.
	
	"For now: save the name of the class in the first line. The source code below."
	^ methodReference actualClass asString , String cr , methodReference category , String cr , methodReference source! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/1/2008 03:12'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/1/2008 18:44'!
extractCategoryFrom: contents

	^ contents lineNumber: 2! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/1/2008 23:23'!
extractClassFrom: contents

	| classStrings theClass |
	classStrings := (contents lineNumber: 1) substrings.
	theClass := Smalltalk at: classStrings first asSymbol.
	^ (classStrings last = 'class')
		ifTrue: [theClass class]
		ifFalse: [theClass].! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/1/2008 18:44'!
extractSourceCodeFrom: aString 
	"Do not read the first 3 line, it's the class name protocol and timestamp.'"
	^ aString
		copyFrom: (aString indexOf: Character cr startingAt: ( aString indexOf: Character cr ) + 1 ) + 1
		to: aString size! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/1/2008 17:51'!
extractTimeStampFrom: contents

	^ Smalltalk at: (contents lineNumber: 1) asSymbol! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 2/1/2008 02:58'!
fileName

	^ self selector asString.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/1/2008 11:38'!
hash

	^ self methodReference hash! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodClass
	
	^ self methodReference actualClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodReference
	
	 ^ methodReference! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/1/2008 02:59'!
methodReference: aMethodReference 
	
	methodReference := aMethodReference.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/1/2008 11:24'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	self methodReference printOn: aStream.
	aStream nextPut: $).! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/1/2008 18:38'!
readElementFrom: aPath 

	| contents |
	contents := self contentsOfFileNamed: aPath.
	self methodReference: (self compileMethodFrom: contents) methodReference.
	methodReference actualClass organization classify: self selector under: (self extractCategoryFrom: contents).
	^ self! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 2/1/2008 02:58'!
selector

	^ self methodReference methodSymbol! !

!SVNMethod methodsFor: 'write' stamp: 'rkrk 2/1/2008 03:56'!
writeElementTo: aPath

	(FileStream forceNewFileNamed: aPath , FileDirectory slash , self fileName)
		nextPutAll: self contentsForFile;
		close.! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
addClass: aClass

	self versionedClasses add: aClass! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:22'!
addMethod: aMethod 
	
	^ self versionedMethods add: (SVNMethod for: aMethod)! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:26'!
allVersionedMethods
	
	| methodsOfClasses |
	methodsOfClasses := self versionedClasses gather: [:eachClass |
		eachClass methodDict collect: [:eachMethod | SVNMethod for: eachMethod]].
	^ self versionedMethods union: methodsOfClasses! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:25'!
versionedMethods
	
	^ versionedMethods! !

Object subclass: #SVNWorkingCopyAccessor
	instanceVariableNames: 'workingCopyPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNWorkingCopyAccessor class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 23:08'!
workingCopyPath: aString 

	^ self new
		workingCopyPath: aString;
		yourself! !

!SVNWorkingCopyAccessor methodsFor: 'svn command line' stamp: 'rkrk 2/3/2008 20:12'!
commandLineSvnAdd: aPath

	self executeViaOSProcessSynchronously: 'svn add ' , aPath.
	! !

!SVNWorkingCopyAccessor methodsFor: 'svn command line' stamp: 'rkrk 2/3/2008 22:40'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 50) wait]].! !

!SVNWorkingCopyAccessor methodsFor: 'testing' stamp: 'rkrk 2/3/2008 22:41'!
file: fileName isAddedToWorkingCopy: pathOfWorkingCopy

	| svnDir wcEntries |
	self flag: #Todo. "File is duplicated from SVNWorkingCopyAccessorTest"
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: self workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	^ wcEntries contents includesSubString: fileName.! !

!SVNWorkingCopyAccessor methodsFor: 'svn primitives' stamp: 'rkrk 2/3/2008 11:55'!
primDeleteDirectory: pathToDirectory

	<primitive: 'deleteDirectory' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNWorkingCopyAccessor methodsFor: 'svn primitives' stamp: 'rkrk 1/7/2008 02:42'!
primSvnAdd: target

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNWorkingCopyAccessor methodsFor: 'svn primitives' stamp: 'rkrk 2/2/2008 18:43'!
primSvnCommit: arrayOfTargets

	<primitive: 'svnCommit' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNWorkingCopyAccessor methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 23:10'!
workingCopyPath

	^ workingCopyPath ! !

!SVNWorkingCopyAccessor methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 23:09'!
workingCopyPath: aString

	workingCopyPath := aString! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/31/2008 05:20'!
answer17

	<primitive: 'answerSeventeen' module: 'PluginAnswering17'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/3/2008 21:34'!
apiTestCall

   <apicall: void 'bla' (void) module: 'test.dll'>
   ^self externalCallFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/3/2008 21:39'!
apiTestCall: asugabe

   <apicall: void 'bla' (char*) module: 'test.dll'>
   ^self externalCallFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:58'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNMethodTest methodsFor: 'test support' stamp: 'rkrk 2/1/2008 04:12'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.

	! !

!SVNMethodTest methodsFor: 'test support' stamp: 'rkrk 2/1/2008 02:10'!
readFileFrom: aDir fileName: aString

	| stream contents |
	stream := aDir oldFileNamed: aString.
	contents := stream contents.
	stream close.
	^contents! !

!SVNMethodTest methodsFor: 'running' stamp: 'rkrk 2/1/2008 04:17'!
tearDown

	super tearDown.
	SVNDummy
		methodDict at: #m2
		ifAbsent: [SVNDummy compile: SVNDummy sourceCodeForM2].! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'cop 2/1/2008 18:43'!
testContentsToWrite

	| method expected result |
	method := SVNMethod for: SVNDummy >> #m1.
	expected := 'SVNDummy', String cr, 'dummy methods
m1
	^ 1'.
	
	result := method contentsForFile.
	self assert: expected = result.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/1/2008 22:12'!
testContentsToWriteCaseMetaClass

	| method expected result |
	method := SVNMethod for: SVNDummy class >> #m3.
	expected := 'SVNDummy class', String cr, 'dummy
m3

	^ 3'.
	
	result := method contentsForFile.
	self assert: expected = result.! !

!SVNMethodTest methodsFor: 'tests' stamp: 'cop 1/31/2008 15:28'!
testEquals

	| methodBlock method1 method2 |

	methodBlock := [SVNMethod methodReference: (SVNDummy>>#m1) methodReference].
	method1 := methodBlock value.
	method2 := methodBlock value.

	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/1/2008 22:22'!
testExtractMetaClass

	| source method result expected |
	method := SVNMethod new.
	source := 'SVNDummy class', String cr , 'dummy' , String cr , 'm4 ^ 4'.
	
	result :=method extractClassFrom: source.
	expected := SVNDummy class.
	self assert: result = expected.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'cop 2/1/2008 18:42'!
testRead

	| method expectedSource methodName fileName |
	methodName := 'm2'.

	expectedSource := 'SVNDummy', String cr, 'dummy methods',String cr, SVNDummy sourceCodeForM2.
	SVNDummy removeSelector: methodName asSymbol.

	fileName := self pathForTests , FileDirectory slash , methodName.
	self inFile: fileName write: expectedSource.
	
	method := SVNMethod readElementFrom: fileName.
	self assert: expectedSource = method contentsForFile.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'cop 2/1/2008 18:43'!
testWrite

	| method contents expected fileName |
	method := SVNMethod for: SVNDummy >> #m1.
	fileName := self pathForTests , FileDirectory slash , method fileName.
	self ensureThatFileNotExist: fileName.
	method writeElementTo: self pathForTests.
	contents := (FileStream readOnlyFileNamed: fileName) contentsOfEntireFile.
	expected := 'SVNDummy', String cr, 'dummy methods
m1
	^ 1'.
	
	self assert: expected = contents.
	
	self ensureThatFileNotExist: fileName.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/1/2008 22:12'!
testWriteRead
	| method fileName readMethod |
	method := SVNMethod for: SVNDummy >> #m1.
	fileName := self
		createPathToFile: method fileName
		inDirectory: self pathForTests.
	self ensureThatFileNotExist: fileName.
	method writeElementTo: self pathForTests.
	readMethod := SVNMethod readElementFrom: fileName.
	self assert: method = readMethod.
	self ensureThatFileNotExist: fileName! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/2/2008 19:24'!
testAddClass

	| sut aClass methodsOfClass result |
	sut := SVNProject new.
	aClass := SVNDummy.
	sut addClass: aClass.
	
	self assert: (sut versionedClasses includes: aClass).
	
	methodsOfClass := aClass methodDict collect: [:ea | SVNMethod for: ea].
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 1/6/2008 21:46'!
testAddMethod
	
	| sut aMethod svnMethod |
	sut := SVNProject new.
	aMethod := SVNDummy >> #m1.
	sut addMethod: aMethod.
	
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	
	self assert: svnMethod methodClass = aMethod methodClass.
	self assert: svnMethod selector = aMethod selector! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:34'!
createPathToFile: filename inDirectory: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:30'!
ensureThatFileNotExist: fileName

	FileDirectory deleteFilePath: fileName! !

!SVNTestCase methodsFor: 'OSProcess' stamp: 'rkrk 2/3/2008 22:43'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 50) wait]].! !

!SVNTestCase methodsFor: 'test support' stamp: 'cop 2/1/2008 18:45'!
pathForTests

	"If you touch the path, reset it before commit!!'"
	"^'C:\test'"
	^ SmalltalkImage current imagePath , FileDirectory slash , 'svnTests'! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/1/2008 15:39'!
setUp

	super setUp.
	(FileDirectory on: self pathForTests) assureExistence.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:24'!
slash

	^ FileDirectory slash! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/3/2008 22:43'!
tearDown

	super tearDown.
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [(FileDirectory on: self pathForTests) recursiveDelete]
		ifTrue: [self executeViaOSProcessSynchronously: 'delete_svnTests.bat'].! !

SVNTestCase subclass: #SVNWorkingCopyAccessorTest
	instanceVariableNames: 'repositoryPath workingCopyPath fileToAdd sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNWorkingCopyAccessorTest methodsFor: 'assert' stamp: 'rkrk 2/4/2008 14:19'!
assertWorkingCopyIncludesFile: fileName

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName).! !

!SVNWorkingCopyAccessorTest methodsFor: 'helper' stamp: 'rkrk 2/3/2008 22:55'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNWorkingCopyAccessorTest methodsFor: 'helper' stamp: 'rkrk 2/4/2008 13:47'!
createRepository
	
	self assert: (FileDirectory isLegalFileName: repositoryPath).
	self deny: (FileDirectory on: repositoryPath , self slash) exists.
	
	self executeViaOSProcessSynchronously: 'svnadmin create ' , repositoryPath.! !

!SVNWorkingCopyAccessorTest methodsFor: 'helper' stamp: 'rkrk 2/4/2008 13:47'!
createWorkingCopy

	| repositoryURLPath |
	self assert: (FileDirectory on: repositoryPath , self slash) exists.
	self deny: (FileDirectory on: workingCopyPath) exists.
	
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURLPath , ' ' , workingCopyPath! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'test 2/4/2008 14:20'!
setUp

	"self halt."
	super setUp.
	repositoryPath := self pathForTests , self slash , 'repository'.
	workingCopyPath := self pathForTests , self slash , 'workingCopy'.
	self
		createRepository;
		createWorkingCopy.

	fileToAdd := 'testFile'.
	self createFile: workingCopyPath , self slash , 'testFile'.
	
	sut := SVNWorkingCopyAccessor workingCopyPath: workingCopyPath.! !

!SVNWorkingCopyAccessorTest methodsFor: 'this does not belong here' stamp: 'rkrk 2/3/2008 19:30'!
svnCommit: aPath

	"Does not belong here!!"
	self executeViaOSProcessSynchronously: 'svn commit ', aPath, ' -m"log"'.! !

!SVNWorkingCopyAccessorTest methodsFor: 'tests' stamp: 'rkrk 2/4/2008 14:19'!
testCommandLineSVNAdd

	sut commandLineSvnAdd: workingCopyPath , self slash , fileToAdd.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNWorkingCopyAccessorTest methodsFor: 'tests' stamp: 'rkrk 2/4/2008 14:21'!
testPrimSVNAdd

	sut primSvnAdd: workingCopyPath , self slash , fileToAdd.
	self assertWorkingCopyIncludesFile: fileToAdd.! !
